diff --git a/contrib/ntp/include/ntp_stdlib.h b/contrib/ntp/include/ntp_stdlib.h
index 446837e3adcb..6f667fbabed7 100644
--- a/contrib/ntp/include/ntp_stdlib.h
+++ b/contrib/ntp/include/ntp_stdlib.h
@@ -11,10 +11,12 @@
 
 #include "declcond.h"	/* ntpd uses ntpd/declcond.h, others include/ */
 #include "l_stdlib.h"
+#include "lib_strbuf.h"
 #include "ntp_md5.h"
 #include "ntp_net.h"
 #include "ntp_debug.h"
 #include "ntp_malloc.h"
+#include "lib_strbuf.h"
 #include "ntp_string.h"
 #include "ntp_syslog.h"
 #include "ntp_keyacc.h"
@@ -113,7 +115,7 @@ extern	size_t	MD5authencrypt	(int type, const u_char *key, size_t klen,
 extern	int	MD5authdecrypt	(int type, const u_char *key, size_t klen,
 				 u_int32 *pkt, size_t length, size_t size,
 				 keyid_t keyno);
-extern	u_int32	addr2refid(sockaddr_u *);
+extern	u_int32	addr2refid	(sockaddr_u *);
 
 /* authkeys.c */
 extern	void	MD5auth_setkey	(keyid_t, int, const u_char *, size_t,
@@ -180,7 +182,6 @@ extern	const char * k_st_flags	(u_int32);
 extern	char *	statustoa	(int, int);
 extern	sockaddr_u * netof	(sockaddr_u *);
 extern	char *	numtoa		(u_int32);
-extern	char *	numtohost	(u_int32);
 extern	const char * socktoa	(const sockaddr_u *);
 extern	const char * sockporttoa(const sockaddr_u *);
 extern	u_short	sock_hash	(const sockaddr_u *);
@@ -242,18 +243,21 @@ extern pset_tod_using	set_tod_using;
 #ifdef OPENSSL
 extern	void	ssl_init		(void);
 extern	void	ssl_check_version	(void);
-extern	int	ssl_init_done;
+extern	EVP_MD_CTX* digest_ctx;		/* also ssl_init_done */
 #define	INIT_SSL()				\
 	do {					\
-		if (!ssl_init_done)		\
+		if (NULL == digest_ctx)	{	\
 			ssl_init();		\
-	} while (0)
+		}				\
+	} while (FALSE)
 #else	/* !OPENSSL follows */
+#define ssl_check_version()	do {} while (0)
 #define	INIT_SSL()		do {} while (0)
 #endif
-extern	int	keytype_from_text	(const char *,	size_t *);
-extern	const char *keytype_name	(int);
-extern	char *	getpass_keytype		(int);
+extern	int	keytype_from_text	(const char *text,
+					 size_t *pdigest_len);
+extern	const char *keytype_name	(int type);
+extern	char *	getpass_keytype		(int type);
 
 /* strl-obsd.c */
 #ifndef HAVE_STRLCPY		/* + */
diff --git a/contrib/ntp/include/ntp_tty.h b/contrib/ntp/include/ntp_tty.h
index 6dc48b6c71f1..56f75c115907 100644
--- a/contrib/ntp/include/ntp_tty.h
+++ b/contrib/ntp/include/ntp_tty.h
@@ -100,4 +100,9 @@ extern	int	ntp_tty_ioctl(int, u_int);
 # endif
 #endif
 
+extern	int	symBaud2numBaud(int symBaud);
+# if 0
+extern	int	numBaud2symBaud(int numBaud);
+#endif
+
 #endif /* NTP_TTY_H */
diff --git a/contrib/ntp/include/ntp_types.h b/contrib/ntp/include/ntp_types.h
index c3cf2c196521..6553f01b8a97 100644
--- a/contrib/ntp/include/ntp_types.h
+++ b/contrib/ntp/include/ntp_types.h
@@ -254,16 +254,6 @@ aligned_ptr(
 	return base + ALIGN_UNITS((minsize < 1) ? 1 : minsize);
 }
 
-/*
- * Macro to use in otherwise-empty source files to comply with ANSI C
- * requirement that each translation unit (source file) contain some
- * declaration.  This has commonly been done by declaring an unused
- * global variable of type int or char.  An extern reference to abs()
- * serves the same purpose without bloat.  We once used exit() but
- * that can produce warnings on systems that declare exit() noreturn.
- */
-#define	NONEMPTY_TRANSLATION_UNIT	extern int abs(int);
-
 /*
  * On Unix struct sock_timeval is equivalent to struct timeval.
  * On Windows built with 64-bit time_t, sock_timeval.tv_sec is a long
diff --git a/contrib/ntp/include/ntpd.h b/contrib/ntp/include/ntpd.h
index ad3e30fbb889..7de19d72de5a 100644
--- a/contrib/ntp/include/ntpd.h
+++ b/contrib/ntp/include/ntpd.h
@@ -47,6 +47,17 @@
 # define DPRINTF(lvl, arg)	do {} while (0)
 #endif
 
+/* clear bitflag only on DEBUG builds */
+#ifdef DEBUG
+# define CLEAR_BIT_IF_DEBUG(bit, flags)			\
+	do {						\
+		(flags) &= ~(bit);			\
+	} while (FALSE)
+#else
+# define CLEAR_BIT_IF_DEBUG(bit, flags)			\
+	do {} while (FALSE)
+#endif
+
 
 /* nt_clockstuff.c */
 #ifdef SYS_WINNT
@@ -60,15 +71,15 @@ extern	char *	saveconfigdir;	/* ntpq saveconfig output directory */
 
 extern	void	getconfig	(int, char **);
 extern	void	ctl_clr_stats	(void);
-extern	int	ctlclrtrap	(sockaddr_u *, struct interface *, int);
+extern	int	ctlclrtrap	(sockaddr_u *, endpt *, int);
 extern	u_short ctlpeerstatus	(struct peer *);
-extern	int	ctlsettrap	(sockaddr_u *, struct interface *, int, int);
+extern	int	ctlsettrap	(sockaddr_u *, endpt *, int, int);
 extern	u_short ctlsysstatus	(void);
 extern	void	init_control	(void);
 extern	void	process_control (struct recvbuf *, int);
 extern	void	report_event	(int, struct peer *, const char *);
-extern	int	mprintf_event	(int, struct peer *, const char *, ...)
-			NTP_PRINTF(3, 4);
+extern	int	mprintf_event	(int evcode, struct peer *p,
+				 const char *fmt, ...) NTP_PRINTF(3, 4);
 
 /* ntp_control.c */
 /*
@@ -118,7 +129,9 @@ extern	void	enable_broadcast	(endpt *, sockaddr_u *);
 extern	void	enable_multicast_if	(endpt *, sockaddr_u *);
 extern	void	interface_update	(interface_receiver_t, void *);
 #ifndef HAVE_IO_COMPLETION_PORT
-extern  void    io_handler              (void);
+extern	void	io_handler		(void);
+#else
+extern	void WINAPI ip_interface_changed(ULONG_PTR ctx);
 #endif
 extern	void	init_io 	(void);
 extern	void	io_open_sockets	(void);
@@ -127,8 +140,10 @@ extern	void	io_setbclient	(void);
 extern	void	io_unsetbclient	(void);
 extern	void	io_multicast_add(sockaddr_u *);
 extern	void	io_multicast_del(sockaddr_u *);
-extern	void	sendpkt 	(sockaddr_u *, struct interface *, int, struct pkt *, int);
-#ifdef DEBUG
+extern	void	sendpkt		(sockaddr_u *dest, endpt * ep, int ttl,
+				 struct pkt *pkt, int len);
+extern	isc_boolean_t	is_linklocal(sockaddr_u *psau);
+#ifdef DEBUG_TIMING
 extern	void	collect_timing  (struct recvbuf *, const char *, int, l_fp *);
 #endif
 #ifdef HAVE_SIGNALED_IO
@@ -141,8 +156,13 @@ extern	void	block_io_and_alarm	(void);
 # define	UNBLOCK_IO_AND_ALARM()	do {} while (0)
 # define	BLOCK_IO_AND_ALARM()	do {} while (0)
 #endif
-#define		latoa(pif)	localaddrtoa(pif)
+#define		eptoa(pif)	localaddrtoa(pif)
+#define		latoa(pif)	eptoa(pif)
 extern const char * localaddrtoa(endpt *);
+#ifdef DEBUG
+extern const char * iflags_str(u_int32 iflags);
+#endif
+
 
 /* ntp_loopfilter.c */
 extern	void	init_loopfilter(void);
@@ -198,7 +218,7 @@ extern	int	crypto_xmit	(struct peer *, struct pkt *,
 				    struct exten *, keyid_t);
 extern	keyid_t	session_key	(sockaddr_u *, sockaddr_u *, keyid_t,
 				    keyid_t, u_long);
-extern	int	make_keylist	(struct peer *, struct interface *);
+extern	int	make_keylist	(struct peer *, endpt *);
 extern	void	key_expire	(struct peer *);
 extern	void	crypto_update	(void);
 extern	void	crypto_update_taichange(void);
@@ -226,7 +246,7 @@ extern	void	clock_select	(void);
 extern	void	set_sys_leap	(u_char);
 
 extern	u_long	leapsec;	/* seconds to next leap (proximity class) */
-extern  int     leapdif;        /* TAI difference step at next leap second*/
+extern  int	leapdif;	/* TAI difference step at next leap second */
 extern	int	sys_orphan;
 extern	double	sys_mindisp;
 extern	double	sys_maxdist;
@@ -258,18 +278,27 @@ extern	void	reset_auth_stats(void);
 /* ntp_restrict.c */
 extern	void	init_restrict	(void);
 extern	void	restrictions	(sockaddr_u *, r4addr *);
-extern	void	hack_restrict	(restrict_op, sockaddr_u *, sockaddr_u *,
-				 short, u_short, u_short, u_long);
-extern	void	restrict_source	(sockaddr_u *, int, u_long);
+extern	int/*BOOL*/hack_restrict(restrict_op op, sockaddr_u *resaddr,
+				 sockaddr_u *resmask, short ippeerlimit,
+				 u_short mflags, u_short rflags,
+				 u_int32 expire);
+extern	void	restrict_source	(sockaddr_u *addr, int/*BOOL*/ remove,
+				 u_int32 lifetime);
+#ifdef DEBUG
 extern	void	dump_restricts	(void);
+extern	const char *resop_str	(restrict_op op);
+extern	const char *rflags_str	(u_short rflags);
+extern	const char *mflags_str	(u_short mflags);
+#endif
+
 
 /* ntp_timer.c */
 extern	void	init_timer	(void);
 extern	void	reinit_timer	(void);
 extern	void	timer		(void);
 extern	void	timer_clr_stats (void);
-extern	void	timer_interfacetimeout (u_long);
-extern	volatile int interface_interval;
+extern	int	endpt_scan_period;	/* -U option default 301s */
+extern	u_long	endpt_scan_timer;	/* next scan current_time */
 extern	u_long	orphwait;		/* orphan wait time */
 #ifdef AUTOKEY
 extern	char	*sys_hostname;	/* host name */
@@ -288,17 +317,29 @@ extern	void	record_proto_stats (char *);
 extern	void	record_loop_stats (double, double, double, double, int);
 extern	void	record_clock_stats (sockaddr_u *, const char *);
 extern	int	mprintf_clock_stats(sockaddr_u *, const char *, ...)
-			NTP_PRINTF(2, 3);
-extern	void	record_raw_stats (sockaddr_u *srcadr, sockaddr_u *dstadr, l_fp *t1, l_fp *t2, l_fp *t3, l_fp *t4, int leap, int version, int mode, int stratum, int ppoll, int precision, double root_delay, double root_dispersion, u_int32 refid, int len, u_char *extra);
+					NTP_PRINTF(2, 3);
+extern	void	record_raw_stats (sockaddr_u *srcadr, sockaddr_u *dstadr,
+				  l_fp *t1, l_fp *t2, l_fp *t3, l_fp *t4,
+				  int leap, int version, int mode,
+				  int stratum, int ppoll, int precision,
+				  double root_delay, double root_dispersion,
+				  u_int32 refid, int len, u_char *extra);
 extern	void	check_leap_file	(int is_daily_check, u_int32 ntptime, const time_t * systime);
 extern	void	record_crypto_stats (sockaddr_u *, const char *);
 #ifdef DEBUG
 extern	void	record_timing_stats (const char *);
+extern	void	append_flagstr(char *flagstr, size_t sz, const char *text);
 #endif
 extern	char *	fstostr(time_t);	/* NTP timescale seconds */
 
 /* ntpd.c */
 extern	void	parse_cmdline_opts(int *, char ***);
+
+/* ntservice.c */
+#ifndef SYS_WINNT
+# define	ntservice_isup()	do {} while (FALSE)
+#endif
+
 /*
  * Signals we catch for debugging.
  */
@@ -381,7 +422,10 @@ extern volatile u_long handler_pkts;	/* number of pkts received by handler */
 extern u_long	io_timereset;		/* time counters were reset */
 
 /* ntp_io.c */
-extern  int	disable_dynamic_updates;
+extern int	no_periodic_scan;	/* no periodic net addr scans */
+extern int	scan_addrs_once;	/* no net addr rescans */
+extern int	nonlocal_v4_addr_up;	/* should we try IPv4 pool? */
+extern int	nonlocal_v6_addr_up;	/* should we try IPv6 pool? */
 extern u_int	sys_ifnum;		/* next .ifnum to assign */
 extern endpt *	any_interface;		/* IPv4 wildcard */
 extern endpt *	any6_interface;		/* IPv6 wildcard */
diff --git a/contrib/ntp/include/vint64ops.h b/contrib/ntp/include/vint64ops.h
index 888d342781fb..50a8c4016264 100644
--- a/contrib/ntp/include/vint64ops.h
+++ b/contrib/ntp/include/vint64ops.h
@@ -23,6 +23,6 @@ extern vint64 subv64i32(const vint64 * lhs, int32_t rhs);
 extern vint64 subv64u32(const vint64 * lhs, uint32_t rhs);
 
 /* parsing. works like strtoul() or strtoull() */
-extern vint64 strtouv64(char const * begp, char const ** const endp, int base);
+extern vint64 strtouv64(char * begp, char ** endp, int base);
 
 #endif /*!defined(VINT64OPS_H)*/
diff --git a/contrib/ntp/libntp/Makefile.am b/contrib/ntp/libntp/Makefile.am
index 99ce273d4cd1..85ac6e3f9b92 100644
--- a/contrib/ntp/libntp/Makefile.am
+++ b/contrib/ntp/libntp/Makefile.am
@@ -192,7 +192,6 @@ libntp_a_SRCS =						\
 	ntp_rfc2553.c					\
 	ntp_worker.c					\
 	numtoa.c					\
-	numtohost.c					\
 	octtoint.c					\
 	prettydate.c					\
 	refidsmear.c					\
diff --git a/contrib/ntp/libntp/a_md5encrypt.c b/contrib/ntp/libntp/a_md5encrypt.c
index 7a372969123f..a571405a5d87 100644
--- a/contrib/ntp/libntp/a_md5encrypt.c
+++ b/contrib/ntp/libntp/a_md5encrypt.c
@@ -21,7 +21,6 @@ typedef struct {
 	size_t		len;
 } rwbuffT;
 
-
 #if defined(OPENSSL) && defined(ENABLE_CMAC)
 static size_t
 cmac_ctx_size(
@@ -40,6 +39,37 @@ cmac_ctx_size(
 #endif	/* OPENSSL && ENABLE_CMAC */
 
 
+/*
+ * Allocate and initialize a digest context.  As a speed optimization,
+ * take an idea from ntpsec and cache the context to avoid malloc/free
+ * overhead in time-critical paths.  ntpsec also caches the algorithms
+ * with each key.
+ * This is not thread-safe, but that is
+ * not a problem at present.
+ */
+static EVP_MD_CTX *
+get_md_ctx(
+	int		nid
+	)
+{
+#ifndef OPENSSL
+	static MD5_CTX	md5_ctx;
+
+	DEBUG_INSIST(NID_md5 == nid);
+	MD5Init(&md5_ctx);
+
+	return &md5_ctx;
+#else
+	if (!EVP_DigestInit(digest_ctx, EVP_get_digestbynid(nid))) {
+		msyslog(LOG_ERR, "%s init failed", OBJ_nid2sn(nid));
+		return NULL;
+	}
+
+	return digest_ctx;
+#endif	/* OPENSSL */
+}
+
+
 static size_t
 make_mac(
 	const rwbuffT *	digest,
@@ -99,26 +129,13 @@ make_mac(
 			CMAC_CTX_free(ctx);
 	}
 	else
-#   endif /*ENABLE_CMAC*/
+#   endif /* ENABLE_CMAC */
 	{	/* generic MAC handling */
-		EVP_MD_CTX *	ctx   = EVP_MD_CTX_new();
+		EVP_MD_CTX *	ctx;
 		u_int		uilen = 0;
 
-		if ( ! ctx) {
-			msyslog(LOG_ERR, "MAC encrypt: MAC %s Digest CTX new failed.",
-				OBJ_nid2sn(ktype));
-			goto mac_fail;
-		}
-
-	   #ifdef EVP_MD_CTX_FLAG_NON_FIPS_ALLOW
-		/* make sure MD5 is allowd */
-		EVP_MD_CTX_set_flags(ctx, EVP_MD_CTX_FLAG_NON_FIPS_ALLOW);
-	   #endif
-		/* [Bug 3457] DON'T use plain EVP_DigestInit! It would
-		 * kill the flags! */
-		if (!EVP_DigestInit_ex(ctx, EVP_get_digestbynid(ktype), NULL)) {
-			msyslog(LOG_ERR, "MAC encrypt: MAC %s Digest Init failed.",
-				OBJ_nid2sn(ktype));
+		ctx = get_md_ctx(ktype);
+		if (NULL == ctx) {
 			goto mac_fail;
 		}
 		if ((size_t)EVP_MD_CTX_size(ctx) > digest->len) {
@@ -143,39 +160,25 @@ make_mac(
 		}
 	  mac_fail:
 		retlen = (size_t)uilen;
-
-		if (ctx)
-			EVP_MD_CTX_free(ctx);
 	}
 
 #else /* !OPENSSL follows */
 
-	if (ktype == NID_md5)
-	{
-		EVP_MD_CTX *	ctx   = EVP_MD_CTX_new();
-		u_int		uilen = 0;
+	if (NID_md5 == ktype) {
+		EVP_MD_CTX *	ctx;
 
-		if (digest->len < 16) {
+		ctx = get_md_ctx(ktype);
+		if (digest->len < MD5_LENGTH) {
 			msyslog(LOG_ERR, "%s", "MAC encrypt: MAC md5 buf too small.");
+		} else {
+			MD5Init(ctx);
+			MD5Update(ctx, (const void *)key->buf, key->len);
+			MD5Update(ctx, (const void *)msg->buf, msg->len);
+			MD5Final(digest->buf, ctx);
+			retlen = MD5_LENGTH;
 		}
-		else if ( ! ctx) {
-			msyslog(LOG_ERR, "%s", "MAC encrypt: MAC md5 Digest CTX new failed.");
-		}
-		else if (!EVP_DigestInit(ctx, EVP_get_digestbynid(ktype))) {
-			msyslog(LOG_ERR, "%s", "MAC encrypt: MAC md5 Digest INIT failed.");
-		}
-		else {
-			EVP_DigestUpdate(ctx, key->buf, key->len);
-			EVP_DigestUpdate(ctx, msg->buf, msg->len);
-			EVP_DigestFinal(ctx, digest->buf, &uilen);
-		}
-		if (ctx)
-			EVP_MD_CTX_free(ctx);
-		retlen = (size_t)uilen;
-	}
-	else
-	{
-		msyslog(LOG_ERR, "MAC encrypt: invalid key type %d"  , ktype);
+	} else {
+		msyslog(LOG_ERR, "MAC encrypt: invalid key type %d", ktype);
 	}
 
 #endif /* !OPENSSL */
@@ -187,7 +190,7 @@ make_mac(
 /*
  * MD5authencrypt - generate message digest
  *
- * Returns length of MAC including key ID and digest.
+ * Returns 0 on failure or length of MAC including key ID.
  */
 size_t
 MD5authencrypt(
@@ -202,13 +205,14 @@ MD5authencrypt(
 	rwbuffT digb = { digest, sizeof(digest) };
 	robuffT keyb = { key, klen };
 	robuffT msgb = { pkt, length };
-	size_t	dlen = 0;
+	size_t	dlen;
 
 	dlen = make_mac(&digb, type, &keyb, &msgb);
-	/* If the MAC is longer than the MAX then truncate it. */
-	if (dlen > MAX_MDG_LEN)
-		dlen = MAX_MDG_LEN;
-	memcpy((u_char *)pkt + length + KEY_MAC_LEN, digest, dlen);
+	if (0 == dlen) {
+		return 0;
+	}
+	memcpy((u_char *)pkt + length + KEY_MAC_LEN, digest,
+	       min(dlen, MAX_MDG_LEN));
 	return (dlen + KEY_MAC_LEN);
 }
 
@@ -236,15 +240,11 @@ MD5authdecrypt(
 	size_t	dlen = 0;
 
 	dlen = make_mac(&digb, type, &keyb, &msgb);
-
-	/* If the MAC is longer than the MAX then truncate it. */
-	if (dlen > MAX_MDG_LEN)
-		dlen = MAX_MDG_LEN;
-	if (size != (size_t)dlen + KEY_MAC_LEN) {
+	if (0 == dlen || size != dlen + KEY_MAC_LEN) {
 		msyslog(LOG_ERR,
-			"MAC decrypt: MAC length error: len=%u key=%d",
-			(u_int)size, keyno);
-		return (0);
+			"MAC decrypt: MAC length error: %u not %u for key %u",
+			(u_int)size, (u_int)(dlen + KEY_MAC_LEN), keyno);
+		return FALSE;
 	}
 	return !isc_tsmemcmp(digest,
 		 (u_char *)pkt + length + KEY_MAC_LEN, dlen);
@@ -254,39 +254,36 @@ MD5authdecrypt(
  * Calculate the reference id from the address. If it is an IPv4
  * address, use it as is. If it is an IPv6 address, do a md5 on
  * it and use the bottom 4 bytes.
- * The result is in network byte order.
+ * The result is in network byte order for IPv4 addreseses.  For
+ * IPv6, ntpd long differed in the hash calculated on big-endian
+ * vs. little-endian because the first four bytes of the MD5 hash
+ * were used as a u_int32 without any byte swapping.  This broke
+ * the refid-based loop detection between mixed-endian systems.
+ * In order to preserve behavior on the more-common little-endian
+ * systems, the hash is now byte-swapped on big-endian systems to
+ * match the little-endian hash.  This is ugly but it seems better
+ * than changing the IPv6 refid calculation on the more-common
+ * systems.
+ * This is not thread safe, not a problem so far.
  */
 u_int32
 addr2refid(sockaddr_u *addr)
 {
-	u_char		digest[EVP_MAX_MD_SIZE];
-	u_int32		addr_refid;
-	EVP_MD_CTX	*ctx;
-	u_int		len;
+	static MD5_CTX	md5_ctx;
+	union u_tag {
+		u_char		digest[MD5_DIGEST_LENGTH];
+		u_int32		addr_refid;
+	} u;
 
-	if (IS_IPV4(addr))
+	if (IS_IPV4(addr)) {
 		return (NSRCADR(addr));
-
-	INIT_SSL();
-
-	ctx = EVP_MD_CTX_new();
-#   ifdef EVP_MD_CTX_FLAG_NON_FIPS_ALLOW
-	/* MD5 is not used as a crypto hash here. */
-	EVP_MD_CTX_set_flags(ctx, EVP_MD_CTX_FLAG_NON_FIPS_ALLOW);
-#   endif
-	/* [Bug 3457] DON'T use plain EVP_DigestInit! It would kill the
-	 * flags! */
-	if (!EVP_DigestInit_ex(ctx, EVP_md5(), NULL)) {
-		msyslog(LOG_ERR,
-		    "MD5 init failed");
-		EVP_MD_CTX_free(ctx);	/* pedantic... but safe */
-		exit(1);
 	}
-
-	EVP_DigestUpdate(ctx, (u_char *)PSOCK_ADDR6(addr),
-	    sizeof(struct in6_addr));
-	EVP_DigestFinal(ctx, digest, &len);
-	EVP_MD_CTX_free(ctx);
-	memcpy(&addr_refid, digest, sizeof(addr_refid));
-	return (addr_refid);
+	/* MD5 is not used for authentication here. */
+	MD5Init(&md5_ctx);
+	MD5Update(&md5_ctx, (void *)&SOCK_ADDR6(addr), sizeof(SOCK_ADDR6(addr)));
+	MD5Final(u.digest, &md5_ctx);
+#ifdef WORDS_BIGENDIAN
+	u.addr_refid = BYTESWAP32(u.addr_refid);
+#endif
+	return u.addr_refid;
 }
diff --git a/contrib/ntp/libntp/adjtime.c b/contrib/ntp/libntp/adjtime.c
index b536cc555d9a..57accd68642d 100644
--- a/contrib/ntp/libntp/adjtime.c
+++ b/contrib/ntp/libntp/adjtime.c
@@ -381,6 +381,6 @@ adjtime (struct timeval *delta, struct timeval *olddelta)
     return 0;
 }
 # else /* no special adjtime() needed */
-int adjtime_bs;
+NONEMPTY_TRANSLATION_UNIT
 # endif
 #endif
diff --git a/contrib/ntp/libntp/audio.c b/contrib/ntp/libntp/audio.c
index f404cc078bdc..2cbae7a30a11 100644
--- a/contrib/ntp/libntp/audio.c
+++ b/contrib/ntp/libntp/audio.c
@@ -517,5 +517,5 @@ audio_show(void)
 #endif /* not PCM_STYLE_SOUND */
 }
 #else
-int audio_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif /* HAVE_{SYS_AUDIOIO,SUN_AUDIOIO,MACHINE_SOUNDCARD,SYS_SOUNDCARD}_H */
diff --git a/contrib/ntp/libntp/authkeys.c b/contrib/ntp/libntp/authkeys.c
index d28b4b932b84..29671ac922bb 100644
--- a/contrib/ntp/libntp/authkeys.c
+++ b/contrib/ntp/libntp/authkeys.c
@@ -611,6 +611,9 @@ authhavekey(
 
 	/*
 	 * The key is found and trusted. Initialize the key cache.
+	 * The cache really should be a struct savekey to streamline
+	 * this code.  Using a sk pointer would be even faster but more
+	 * fragile around pointing to freed memory.
 	 */
 	cache_keyid = sk->keyid;
 	cache_type = sk->type;
@@ -927,6 +930,7 @@ authdecrypt(
 			      pkt, length, size, keyno);
 }
 
+
 /* password decoding helpers */
 static size_t
 pwdecode_plain(
diff --git a/contrib/ntp/libntp/authreadkeys.c b/contrib/ntp/libntp/authreadkeys.c
index fa2f5b540de4..e4aee723d33a 100644
--- a/contrib/ntp/libntp/authreadkeys.c
+++ b/contrib/ntp/libntp/authreadkeys.c
@@ -218,14 +218,14 @@ authreadkeys(
 		keytype = keytype_from_text(token, NULL);
 		if (keytype == 0) {
 			log_maybe(NULL,
-				  "authreadkeys: invalid type for key %d",
-				  keyno);
+				  "authreadkeys: unsupported type %s for key %d",
+				  token, keyno);
 #  ifdef ENABLE_CMAC
 		} else if (NID_cmac != keytype &&
 				EVP_get_digestbynid(keytype) == NULL) {
 			log_maybe(NULL,
-				  "authreadkeys: no algorithm for key %d",
-				  keyno);
+				  "authreadkeys: no algorithm for %s key %d",
+				  token, keyno);
 			keytype = 0;
 #  endif /* ENABLE_CMAC */
 		}
@@ -270,11 +270,13 @@ authreadkeys(
 					  "authreadkeys: passwd has bad char for key %d",
 					  keyno);
 				break;
+#ifdef DEBUG
 			default:
 				log_maybe(&nerr,
-					  "authreadkeys: unknown errno %d for key %d",
+					  "authreadkeys: unexpected errno %d for key %d: %m",
 					  errno, keyno);
 				break;
+#endif
 			}
 			continue;
 		}
diff --git a/contrib/ntp/libntp/bsd_strerror.c b/contrib/ntp/libntp/bsd_strerror.c
index 5ace9aa48542..23888a2d1437 100644
--- a/contrib/ntp/libntp/bsd_strerror.c
+++ b/contrib/ntp/libntp/bsd_strerror.c
@@ -45,5 +45,5 @@ strerror(
 	return ebuf;
 }
 #else
-int strerror_bs;
+NONEMPTY_TRANSLATION_UNIT
 #endif
diff --git a/contrib/ntp/libntp/clocktypes.c b/contrib/ntp/libntp/clocktypes.c
index de7f6b4f3854..1b44546ee172 100644
--- a/contrib/ntp/libntp/clocktypes.c
+++ b/contrib/ntp/libntp/clocktypes.c
@@ -6,7 +6,6 @@
 
 #include "ntp_fp.h"
 #include "ntp.h"
-#include "lib_strbuf.h"
 #include "ntp_refclock.h"
 #include "ntp_stdlib.h"
 
diff --git a/contrib/ntp/libntp/dofptoa.c b/contrib/ntp/libntp/dofptoa.c
index c21d1455e7f0..a3f7c9e710dd 100644
--- a/contrib/ntp/libntp/dofptoa.c
+++ b/contrib/ntp/libntp/dofptoa.c
@@ -5,8 +5,6 @@
 #include <stdio.h>
 
 #include "ntp_fp.h"
-#include "lib_strbuf.h"
-#include "ntp_string.h"
 #include "ntp_stdlib.h"
 
 char *
diff --git a/contrib/ntp/libntp/dolfptoa.c b/contrib/ntp/libntp/dolfptoa.c
index 00e1faf793bc..2fa3cc5502d6 100644
--- a/contrib/ntp/libntp/dolfptoa.c
+++ b/contrib/ntp/libntp/dolfptoa.c
@@ -5,8 +5,6 @@
 #include <stdio.h>
 
 #include "ntp_fp.h"
-#include "lib_strbuf.h"
-#include "ntp_string.h"
 #include "ntp_stdlib.h"
 
 char *
diff --git a/contrib/ntp/libntp/humandate.c b/contrib/ntp/libntp/humandate.c
index d9d5e89df017..94b3e6023e17 100644
--- a/contrib/ntp/libntp/humandate.c
+++ b/contrib/ntp/libntp/humandate.c
@@ -6,7 +6,6 @@
 
 #include "ntp_fp.h"
 #include "ntp_unixtime.h"	/* includes <sys/time.h> and <time.h> */
-#include "lib_strbuf.h"
 #include "ntp_stdlib.h"
 
 
diff --git a/contrib/ntp/libntp/lib/isc/win32/strerror.c b/contrib/ntp/libntp/lib/isc/win32/strerror.c
index 40c5da002f8c..21bdad97778e 100644
--- a/contrib/ntp/libntp/lib/isc/win32/strerror.c
+++ b/contrib/ntp/libntp/lib/isc/win32/strerror.c
@@ -29,6 +29,8 @@
 #include <isc/strerror.h>
 #include <isc/util.h>
 
+#include "lib_strbuf.h"
+
 /*
  * Forward declarations
  */
@@ -88,19 +90,47 @@ isc__strerror(int num, char *buf, size_t size) {
  */
 char *
 FormatError(int error) {
-	LPVOID lpMsgBuf = NULL;
+	char *lpMsgBuf = NULL;
+	char *pch;
+	const char boiler[] =
+		" For information about network troubleshooting, see Windows Help.";
+	size_t last;
+
 	FormatMessage( 
 		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
 		FORMAT_MESSAGE_FROM_SYSTEM | 
-		FORMAT_MESSAGE_IGNORE_INSERTS,
+		(FORMAT_MESSAGE_MAX_WIDTH_MASK - 1),
 		NULL,
 		error,
 		/* Default language */
 		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
-		(LPTSTR) &lpMsgBuf,
+		(LPTSTR)(PVOID)&lpMsgBuf,
 		0,
 		NULL); 
 
+	/* remove useless boilerplate */
+	pch = strstr(lpMsgBuf, boiler);
+	if (pch != NULL) {
+		*pch = '\0';
+	}
+
+	/* strip any trailing CR/LF and spaces */
+	if (lpMsgBuf != NULL) {
+		last = strlen(lpMsgBuf);
+		if (last > 0) {
+			--last;
+		}
+		while ('\n' == lpMsgBuf[last] ||
+		       '\r' == lpMsgBuf[last] ||
+		       ' '  == lpMsgBuf[last]) {
+
+			lpMsgBuf[last] = '\0';
+			if (last > 0) {
+				--last;
+			}
+		}
+	}
+
 	return (lpMsgBuf);
 }
 
@@ -113,27 +143,31 @@ char *
 NTstrerror(int err, BOOL *bfreebuf) {
 	char *retmsg = NULL;
 
-	/* Copy the error value first in case of other errors */	
-	DWORD errval = err; 
-
 	*bfreebuf = FALSE;
 
 	/* Get the Winsock2 error messages */
-	if (errval >= WSABASEERR && errval <= (WSABASEERR + 1999)) {
-		retmsg = GetWSAErrorMessage(errval);
-		if (retmsg != NULL)
-			return (retmsg);
+	/* DLH this may not be needed, FormatError/FormatMessage may handle Winsock error codes */
+	if (err >= WSABASEERR && err <= (WSABASEERR + 1999)) {
+		retmsg = GetWSAErrorMessage(err);
 	}
 	/*
 	 * If it's not one of the standard Unix error codes,
 	 * try a system error message
 	 */
-	if (errval > (DWORD) _sys_nerr) {
-		*bfreebuf = TRUE;
-		return (FormatError(errval));
-	} else {
-		return (strerror(errval));
+	if (NULL == retmsg) {
+		if (err > _sys_nerr) {
+			*bfreebuf = TRUE;
+			retmsg = FormatError(err);
+		} else {
+			retmsg = lib_getbuf();
+			if (0 != strerror_s(retmsg, LIB_BUFLENGTH, err)) {
+				snprintf(retmsg, LIB_BUFLENGTH,
+					 "Unknown error number %d/0x%x",
+					 err, err);
+			}
+		}
 	}
+	return retmsg;
 }
 
 /*
diff --git a/contrib/ntp/libntp/lib_strbuf.c b/contrib/ntp/libntp/lib_strbuf.c
index 76f70163de98..225c430f7e02 100644
--- a/contrib/ntp/libntp/lib_strbuf.c
+++ b/contrib/ntp/libntp/lib_strbuf.c
@@ -1,10 +1,11 @@
 /*
- * lib_strbuf - library string storage
+ * lib_strbuf.c - init_lib() and library string storage
  */
 #ifdef HAVE_CONFIG_H
 #include <config.h>
 #endif
 
+#include <isc/mutex.h>
 #include <isc/net.h>
 #include <isc/result.h>
 
@@ -12,17 +13,18 @@
 #include "ntp_stdlib.h"
 #include "lib_strbuf.h"
 
+#define LIB_NUMBUF	10
 
 /*
  * Storage declarations
  */
-int		debug;
-libbufstr	lib_stringbuf[LIB_NUMBUF];
-int		lib_nextbuf;
-int		ipv4_works;
-int		ipv6_works;
-int		lib_inited;
-
+static char		lib_stringbuf_storage[LIB_NUMBUF][LIB_BUFLENGTH];
+static char *		lib_stringbuf[LIB_NUMBUF];
+int			lib_inited;
+static isc_mutex_t	lib_mutex;
+int			ipv4_works;
+int			ipv6_works;
+int			debug;
 
 /*
  * initialization routine.  Might be needed if the code is ROMized.
@@ -30,10 +32,41 @@ int		lib_inited;
 void
 init_lib(void)
 {
-	if (lib_inited)
+	u_int	u;
+
+	if (lib_inited) {
 		return;
+	}
 	ipv4_works = (ISC_R_SUCCESS == isc_net_probeipv4());
 	ipv6_works = (ISC_R_SUCCESS == isc_net_probeipv6());
 	init_systime();
+	/*
+	 * Avoid -Wrestrict warnings by keeping a pointer to each buffer
+	 * so the compiler can see copying from one buffer to another is
+	 * not violating restrict qualifiers on, e.g. memcpy() args.
+	 */
+	for (u = 0; u < COUNTOF(lib_stringbuf); u++) {
+		lib_stringbuf[u] = lib_stringbuf_storage[u];
+	}
+	isc_mutex_init(&lib_mutex);
 	lib_inited = TRUE;
 }
+
+
+char *
+lib_getbuf(void)
+{
+	static int	lib_nextbuf;
+	int		mybuf;
+
+	if (!lib_inited) {
+		init_lib();
+	}
+	isc_mutex_lock(&lib_mutex);
+	mybuf = lib_nextbuf;
+	lib_nextbuf = (1 + mybuf) % COUNTOF(lib_stringbuf);
+	isc_mutex_unlock(&lib_mutex);
+	zero_mem(lib_stringbuf[mybuf], LIB_BUFLENGTH);
+
+	return lib_stringbuf[mybuf];
+}
\ No newline at end of file
diff --git a/contrib/ntp/libntp/machines.c b/contrib/ntp/libntp/machines.c
index 7a29ac07ea5f..163abf15c6db 100644
--- a/contrib/ntp/libntp/machines.c
+++ b/contrib/ntp/libntp/machines.c
@@ -13,17 +13,16 @@
 #include "ntp_syslog.h"
 #include "ntp_stdlib.h"
 #include "ntp_unixtime.h"
-#include "lib_strbuf.h"
 #include "ntp_debug.h"
+#include "ntp_tty.h"
 
 #ifdef HAVE_UNISTD_H
 #include <unistd.h>
 #endif
 
 #ifdef SYS_WINNT
-int _getch(void);	/* Declare the one function rather than include conio.h */
+#include <conio.h>
 #else
-
 #ifdef SYS_VXWORKS
 #include "taskLib.h"
 #include "sysLib.h"
@@ -531,3 +530,58 @@ getpass(const char * prompt)
 	return password;
 }
 #endif /* SYS_WINNT */
+
+
+static const int baudTable[][2] = {
+	{B0, 0},
+	{B50, 50},
+	{B75, 75},
+	{B110, 110},
+	{B134, 134},
+	{B150, 150},
+	{B200, 200},
+	{B300, 300},
+	{B600, 600},
+	{B1200, 1200},
+	{B1800, 1800},
+	{B2400, 2400},
+	{B4800, 4800},
+	{B9600, 9600},
+	{B19200, 19200},
+	{B38400, 38400},
+#   ifdef B57600
+	{B57600, 57600 },
+#   endif
+#   ifdef B115200
+	{B115200, 115200},
+#   endif
+	{-1, -1}
+};
+
+
+int  symBaud2numBaud(int symBaud)
+{
+	int i;
+
+	for (i = 0; baudTable[i][1] >= 0; ++i) {
+		if (baudTable[i][0] == symBaud) {
+			break;
+		}
+	}
+	return baudTable[i][1];
+}
+
+
+#if 0	/* unused */
+int  numBaud2symBaud(int numBaud)
+{
+	int i;
+
+	for (i = 0; baudTable[i][1] >= 0; ++i) {
+		if (baudTable[i][1] == numBaud) {
+			break;
+		}
+	}
+	return baudTable[i][0];
+}
+#endif	/* unused fn */
diff --git a/contrib/ntp/libntp/modetoa.c b/contrib/ntp/libntp/modetoa.c
index 6f13d20580bf..de14c9edd34c 100644
--- a/contrib/ntp/libntp/modetoa.c
+++ b/contrib/ntp/libntp/modetoa.c
@@ -4,7 +4,6 @@
 #include <config.h>
 #include <stdio.h>
 
-#include "lib_strbuf.h"
 #include "ntp_stdlib.h"
 
 const char *
diff --git a/contrib/ntp/libntp/msyslog.c b/contrib/ntp/libntp/msyslog.c
index a1ba72792595..b72d5c8dc379 100644
--- a/contrib/ntp/libntp/msyslog.c
+++ b/contrib/ntp/libntp/msyslog.c
@@ -348,15 +348,14 @@ msyslog(
 	...
 	)
 {
-	char	buf[1024];
 	va_list	ap;
 
 	va_start(ap, fmt);
-	mvsnprintf(buf, sizeof(buf), fmt, ap);
+	mvsyslog(level, fmt, ap);
 	va_end(ap);
-	addto_syslog(level, buf);
 }
 
+
 void
 mvsyslog(
 	int		level,
@@ -365,6 +364,7 @@ mvsyslog(
 	)
 {
 	char	buf[1024];
+
 	mvsnprintf(buf, sizeof(buf), fmt, ap);
 	addto_syslog(level, buf);
 }
diff --git a/contrib/ntp/libntp/netof.c b/contrib/ntp/libntp/netof.c
index c8831c3dd9cd..5f1e3662de78 100644
--- a/contrib/ntp/libntp/netof.c
+++ b/contrib/ntp/libntp/netof.c
@@ -1,5 +1,5 @@
 /* 
- * netof - return the net address part of an ip address in a sockaddr_storage structure
+ * netof - return the net address part of an ip address in a sockaddr_u structure
  *         (zero out host part)
  */
 #include <config.h>
@@ -11,12 +11,19 @@
 #include "ntp_stdlib.h"
 #include "ntp.h"
 
+/* 
+ * Return the network portion of a host address.  Used by ntp_io.c
+ * findbcastinter() to find a multicast/broadcast interface for
+ * a given remote address.  Note static storage is used, with room
+ * for only two addresses, which is all that is needed at present.
+ * 
+ */
 sockaddr_u *
 netof(
 	sockaddr_u *hostaddr
 	)
 {
-	static sockaddr_u	netofbuf[8];
+	static sockaddr_u	netofbuf[2];
 	static int		next_netofbuf;
 	u_int32			netnum;
 	sockaddr_u *		netaddr;
@@ -27,20 +34,11 @@ netof(
 	memcpy(netaddr, hostaddr, sizeof(*netaddr));
 
 	if (IS_IPV4(netaddr)) {
-		netnum = SRCADR(netaddr);
-
 		/*
-		 * We live in a modern CIDR world where the basement nets, which
-		 * used to be class A, are now probably associated with each
-		 * host address. So, for class-A nets, all bits are significant.
+		 * We live in a modern classless IPv4 world.  Assume /24.
 		 */
-		if (IN_CLASSC(netnum))
-			netnum &= IN_CLASSC_NET;
-		else if (IN_CLASSB(netnum))
-			netnum &= IN_CLASSB_NET;
-
+		netnum = SRCADR(netaddr) & IN_CLASSC_NET;
 		SET_ADDR4(netaddr, netnum);
-
 	} else if (IS_IPV6(netaddr))
 		/* assume the typical /64 subnet size */
 		zero_mem(&NSRCADR6(netaddr)[8], 8);
diff --git a/contrib/ntp/libntp/ntp_calendar.c b/contrib/ntp/libntp/ntp_calendar.c
index 9fc0b48229f2..b850a9db59b8 100644
--- a/contrib/ntp/libntp/ntp_calendar.c
+++ b/contrib/ntp/libntp/ntp_calendar.c
@@ -56,7 +56,6 @@
 #include "ntp_unixtime.h"
 
 #include "ntpd.h"
-#include "lib_strbuf.h"
 
 /* For now, let's take the conservative approach: if the target property
  * macros are not defined, check a few well-known compiler/architecture
